/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "CAbout.hpp"

CAbout::CAbout() : WProportional(0.5,0.5,0.5,0.5), // centered contents
	_w_close_button("Close")
{
	Add(&_w_vbox);
	SetBackgroundColor(al_map_rgba(0,0,0,210));
	
	_w_vbox.Add(_w_text,0);
	_w_vbox.Add(_w_close_button,1);
	_w_vbox.SetSpacing(20);
	
	_w_text.SetTextColor(al_map_rgb(255,255,255));
	_w_text.SetText(R"(
 Millennium Duel 0.1
Copyright (c) 2013 Rafal Cieslak and Millennium Developers Team.

 Millennium Duel is Free Software, and is released under the terms of
the GNU General Public License (version 3). For details, read the
LICENSE file distributed with Millennium Duel, or head to
http://www.gnu.org/licenses/gpl.txt

 Millennium, Millennium Duel and libMillennium are in no way affiliated
with KONAMI(c) and Yu-Gi-Oh! Trading Card Game. All trademarks and
characters belong to their respective owners.)");
	
	_w_close_button.SetForegroundColor(al_map_rgb(130,100,100));
	_w_close_button.event_activated.Subscribe(this,&CAbout::_ButtonCloseClicked);
}

void CAbout::_ButtonCloseClicked(){
	event_closed.Happen();
}
