#ifndef __CDISPLAY_HPP__
#define __CDISPLAY_HPP__

/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "widgets/IDrawable.hpp"
#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>

class CDisplay{
public:
    static void Init();
    static void MainLoop();
    static void Cleanup();

    static void SetMainWidget(IDrawable& v);
    
    static ALLEGRO_FONT* main_font;

    static void SetWindowSizeSmall();
    static void SetWindowSizeMedium();
    static void SetWindowSizeLarge();
private:
    CDisplay() = delete;
    
    static void _Redraw();
    
    static IDrawable* _main_widget;
    static ALLEGRO_DISPLAY* _display;
    
    static bool _main_widget_changed;
};

#endif //__CDISPLAY_HPP__
