#ifndef __MAIN_MENU_HPP__
#define __MAIN_MENU_HPP__

/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "widgets/WButton.hpp"
#include "widgets/WLabel.hpp"
#include "widgets/WEntry.hpp"
#include "widgets/WFixed.hpp"
#include "widgets/WVBox.hpp"
#include "widgets/WLayeredView.hpp"
#include "widgets/WImage.hpp"
#include "widgets/WProportional.hpp"

class CMainMenu : public WLayeredView{
public:
	CMainMenu();

	CEvent<> event_about_clicked;
	CEvent<> event_options_clicked;
private:
	// First layer
	WProportional _w_prop_1;
	WLabel _w_label_disclaimer;
	
	// Second layer
	WProportional _w_prop_2;
	WVBox _w_vbox_main;
	
	WButton _w_button_join;
	WButton _w_button_host;
	WButton _w_button_options;
	WButton _w_button_about;
	WButton _w_button_quit;
	
	WProportional _w_expanding_text;
	WLabel _w_hint_label;
	
	// Third layer
	WImage _w_bg_image;
	
	void _ButtonQuitClicked();
	void _ButtonAboutClicked();
	void _ButtonOptionsClicked();
	
	void _ButtonJoinMouseIn();
	void _ButtonHostMouseIn();
	void _ButtonAboutMouseIn();
	void _ButtonOptionsMouseIn();
	void _ButtonQuitMouseIn();
	void _ClearHintText();
};

#endif //__MAIN_MENU_HPP__
