/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "COptions.hpp"
#include "CDisplay.hpp"

COptions::COptions() : WProportional(0.5,0.5,0.5,0.5), // centered contents
	_w_caption("Options"),
	_w_close_button("Close"),
	_w_window_size_label("Game window size:"),
	_w_window_size_small("Small"),
	_w_window_size_medium("Medium"),
	_w_window_size_large("Large")
{
	Add(&_w_vbox);
	SetBackgroundColor(al_map_rgba(0,0,0,210));
	_w_vbox.SetBackgroundColor(al_map_rgb(50,50,50));
	_w_vbox.SetMargin(5);
	
	_w_vbox.Add(_w_caption,0);
	_w_vbox.Add(_w_window_size_hbox,1);
	_w_vbox.Add(_w_close_button,2);
	_w_vbox.SetSpacing(10);
	
	_w_window_size_hbox.Add(_w_window_size_label,0);
	_w_window_size_hbox.Add(_w_window_sizes,1);
	
	_w_window_sizes.Add(_w_window_size_small,0);
	_w_window_sizes.Add(_w_window_size_medium,1);
	_w_window_sizes.Add(_w_window_size_large,2);
	_w_window_sizes.SetMargin(3);
	_w_window_sizes.SetSpacing(2);
	_w_window_sizes.SetBackgroundColor(al_map_rgb(60,70,60));
	
	_w_window_size_small.SetForegroundColor(al_map_rgb(120,140,100));
	_w_window_size_medium.SetForegroundColor(al_map_rgb(120,140,100));
	_w_window_size_large.SetForegroundColor(al_map_rgb(120,140,100));
	
	_w_caption.SetTextColor(al_map_rgb(255,255,255));
	_w_window_size_label.SetTextColor(al_map_rgb(255,255,255));
	
	_w_close_button.SetForegroundColor(al_map_rgb(130,100,100));
	_w_close_button.event_activated.Subscribe(this,&COptions::_ButtonCloseClicked);
	
	_w_window_size_small.event_activated.Subscribe( [](){CDisplay::SetWindowSizeSmall();} );
	_w_window_size_medium.event_activated.Subscribe( [](){CDisplay::SetWindowSizeMedium();} );
	_w_window_size_large.event_activated.Subscribe( [](){CDisplay::SetWindowSizeLarge();} );
}

void COptions::_ButtonCloseClicked(){
	event_closed.Happen();
}
