#include "CDisplay.hpp"
#include "CMainMenu.hpp"
#include "CAbout.hpp"
#include "COptions.hpp"
#include "widgets/WLayeredView.hpp"

/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

int main(){
    CDisplay::Init();

    WLayeredView main_view;
    CMainMenu main_menu;
    CAbout about;
    COptions options;
    
    main_view.Add(about,0,BOX_EXPAND,false); //not visible
    main_view.Add(options,1,BOX_EXPAND,false); //not visible
    main_view.Add(main_menu,2);
    
    main_menu.event_about_clicked.Subscribe( [&](){main_view.ShowLayer(about);} );
    about.event_closed.Subscribe( [&](){main_view.HideLayer(about);} );
    
    main_menu.event_options_clicked.Subscribe( [&](){main_view.ShowLayer(options);} );
    options.event_closed.Subscribe( [&](){main_view.HideLayer(options);} );
    
    CDisplay::SetMainWidget(main_view);

    CDisplay::MainLoop();
    
    CDisplay::Cleanup();    
    
    return 0;
}
