/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "IContainer.hpp"

IContainer::IContainer(){
    event_keypress.Subscribe(this,&IContainer::_KeypressReaction);
}

void IContainer::SetFocusedChild(IDrawable* item){
    focused = item;
    IContainer* parent_container = dynamic_cast<IContainer*>(parent);
    if(parent_container != nullptr){
	parent_container->SetFocusedChild(this);
    }
}

void IContainer::_KeypressReaction(SKeypressData k){
    if(focused == nullptr) return;
    focused->OnKeypress(k);
}
