#ifndef __ICONTAINER_HPP__
#define __ICONTAINER_HPP__

/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "IDrawable.hpp"

/* Generic class for all widgets that contain a collection of other
 * widgets and manage them in some way. */
class IContainer : public IDrawable{
public:
    IContainer();

    void SetFocusedChild(IDrawable* item);
    
    IDrawable* focused = nullptr;
private:
    // Used to pass keypresses to child
    void _KeypressReaction(SKeypressData k);
    
};

#endif // __IORDEREDCONTAINER_HPP__
