#ifndef __BUTTON_HPP__
#define __BUTTON_HPP__

/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "IDrawable.hpp"
#include "allegro5/allegro.h"
#include <string>

class WButton : public IDrawable{
public:
    WButton(std::string);
    
    std::string text;
    CEvent<> event_activated;
    
    void SetForegroundColor(ALLEGRO_COLOR);
    void SetTextColor(ALLEGRO_COLOR);
private:
    virtual void _Redraw(int w, int h) override;
	
    ALLEGRO_COLOR foreground_color;
    ALLEGRO_COLOR pointed_color;
    ALLEGRO_COLOR color;
    ALLEGRO_COLOR text_color;
    
    void _ClickReaction(SCoordinates);
    void _MouseInReaction();
    void _MouseOutReaction();
    
    virtual int _GetInnerMinimalHeight() override;
    virtual int _GetInnerMinimalWidth () override;
};

#endif //__BUTTON_HPP__
