/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "WImage.hpp"
#include <allegro5/allegro.h>

#include <iostream>

WImage::WImage(std::string filepath){
    _bitmap = al_load_bitmap(filepath.c_str());
    if(_bitmap == nullptr) throw std::string("Error loading Image file: " + filepath);
    _bitmap_height = al_get_bitmap_height(_bitmap);
    _bitmap_width  = al_get_bitmap_width (_bitmap);
    _height = _bitmap_height;
    _width = _bitmap_width;
}

WImage::~WImage(){
    al_destroy_bitmap(_bitmap);
}

int WImage::_GetInnerMinimalHeight(){return _height;}
int WImage::_GetInnerMinimalWidth (){return _width; }
void WImage::SetMinimalHeight(int h) {_height = h; SetNeedsRedrawing();}
void WImage::SetMinimalWidth (int w) {_width  = w; SetNeedsRedrawing();}

void WImage::_Redraw(int w, int h){
    al_draw_scaled_bitmap(_bitmap,0,0,_bitmap_width,_bitmap_height, 0,0, w, h, 0);
}
