/* This file is part of Millennium Duel.
Copyright 2013 Rafał Cieślak and the Millennium Developers Team

Millennium Duel is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Millennium Duel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with Millennium Duel; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  */

#include "WLabel.hpp"
#include "../CDisplay.hpp"
#include "allegro5/allegro.h"
#include "allegro5/allegro_primitives.h"
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>

//extern ALLEGRO_FONT* main_font;


WLabel::WLabel(std::string _text) : text(_text) {
    SetTextColor(al_map_rgb(0,0,0));
}

void WLabel::SetText(std::string _text){
    text = _text;
    SetNeedsRedrawing();
}

void WLabel::SetTextColor(ALLEGRO_COLOR c){
    text_color = c;
}

void WLabel::_Redraw(int w, int h){
    al_draw_text(CDisplay::main_font, text_color, w/2, h/2 - 8 ,ALLEGRO_ALIGN_CENTRE, text.c_str());
}

int WLabel::_GetInnerMinimalHeight() {return 20;}
int WLabel::_GetInnerMinimalWidth () {
    return al_get_text_width(CDisplay::main_font, text.c_str()) + 6; // 3px margin from both sides
}

